Index: uspace/app/bdsh/input.c
===================================================================
--- uspace/app/bdsh/input.c	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ uspace/app/bdsh/input.c	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -38,5 +38,4 @@
 #include <vfs/vfs.h>
 #include <errno.h>
-#include <assert.h>
 #include <bool.h>
 
@@ -48,26 +47,5 @@
 #include "exec.h"
 
-#define HISTORY_LEN 10
-
-typedef struct {
-	wchar_t buffer[INPUT_MAX];
-	int col0, row0;
-	int con_cols, con_rows;
-	int nc;
-	int pos;
-
-	char *history[1 + HISTORY_LEN];
-	int hnum;
-	int hpos;
-} tinput_t;
-
-typedef enum {
-	seek_backward = -1,
-	seek_forward = 1
-} seek_dir_t;
-
-static tinput_t tinput;
-
-static char *tinput_read(tinput_t *ti);
+static void read_line(char *, int);
 
 /* Tokenizes input from console, sees if the first word is a built-in, if so
@@ -121,323 +99,52 @@
 }
 
-static void tinput_display_tail(tinput_t *ti, int start, int pad)
-{
-	int i;
-
-	console_goto(fphone(stdout), (ti->col0 + start) % ti->con_cols,
-	    ti->row0 + (ti->col0 + start) / ti->con_cols);
-	printf("%ls", ti->buffer + start);
-	for (i = 0; i < pad; ++i)
-		putchar(' ');
-	fflush(stdout);
-}
-
-static char *tinput_get_str(tinput_t *ti)
-{
-	return wstr_to_astr(ti->buffer);
-}
-
-static void tinput_position_caret(tinput_t *ti)
-{
-	console_goto(fphone(stdout), (ti->col0 + ti->pos) % ti->con_cols,
-	    ti->row0 + (ti->col0 + ti->pos) / ti->con_cols);
-}
-
-/** Update row0 in case the screen could have scrolled. */
-static void tinput_update_origin(tinput_t *ti)
-{
-	int width, rows;
-
-	width = ti->col0 + ti->nc;
-	rows = (width / ti->con_cols) + 1;
- 
-	/* Update row0 if the screen scrolled. */
-	if (ti->row0 + rows > ti->con_rows)
-		ti->row0 = ti->con_rows - rows;	
-}
-
-static void tinput_insert_char(tinput_t *ti, wchar_t c)
-{
-	int i;
-	int new_width, new_height;
-
-	if (ti->nc == INPUT_MAX)
-		return;
-
-	new_width = ti->col0 + ti->nc + 1;
-	if (new_width % ti->con_cols == 0) {
-		/* Advancing to new line. */
-		new_height = (new_width / ti->con_cols) + 1;
-		if (new_height >= ti->con_rows)
-			return; /* Disallow text longer than 1 page for now. */
-	}
-
-	for (i = ti->nc; i > ti->pos; --i)
-		ti->buffer[i] = ti->buffer[i - 1];
-
-	ti->buffer[ti->pos] = c;
-	ti->pos += 1;
-	ti->nc += 1;
-	ti->buffer[ti->nc] = '\0';
-
-	tinput_display_tail(ti, ti->pos - 1, 0);
-	tinput_update_origin(ti);
-	tinput_position_caret(ti);
-}
-
-static void tinput_backspace(tinput_t *ti)
-{
-	int i;
-
-	if (ti->pos == 0)
-		return;
-
-	for (i = ti->pos; i < ti->nc; ++i)
-		ti->buffer[i - 1] = ti->buffer[i];
-	ti->pos -= 1;
-	ti->nc -= 1;
-	ti->buffer[ti->nc] = '\0';
-
-	tinput_display_tail(ti, ti->pos, 1);
-	tinput_position_caret(ti);
-}
-
-static void tinput_delete(tinput_t *ti)
-{
-	if (ti->pos == ti->nc)
-		return;
-
-	ti->pos += 1;
-	tinput_backspace(ti);
-}
-
-static void tinput_seek_cell(tinput_t *ti, seek_dir_t dir)
-{
-	if (dir == seek_forward) {
-		if (ti->pos < ti->nc)
-			ti->pos += 1;
-	} else {
-		if (ti->pos > 0)
-			ti->pos -= 1;
-	}
-
-	tinput_position_caret(ti);
-}
-
-static void tinput_seek_word(tinput_t *ti, seek_dir_t dir)
-{
-	if (dir == seek_forward) {
-		if (ti->pos == ti->nc)
-			return;
-
-		while (1) {
-			ti->pos += 1;
-
-			if (ti->pos == ti->nc)
-				break;
-
-			if (ti->buffer[ti->pos - 1] == ' ' &&
-			    ti->buffer[ti->pos] != ' ')
-				break;
-		}
-	} else {
-		if (ti->pos == 0)
-			return;
-
-		while (1) {
-			ti->pos -= 1;
-
-			if (ti->pos == 0)
-				break;
-
-			if (ti->buffer[ti->pos - 1] == ' ' &&
-			    ti->buffer[ti->pos] != ' ')
-				break;
-		}
-
-	}
-
-	tinput_position_caret(ti);
-}
-
-static void tinput_seek_vertical(tinput_t *ti, seek_dir_t dir)
-{
-	if (dir == seek_forward) {
-		if (ti->pos + ti->con_cols <= ti->nc)
-			ti->pos = ti->pos + ti->con_cols;
-	} else {
-		if (ti->pos - ti->con_cols >= 0)
-			ti->pos = ti->pos - ti->con_cols;
-	}
-
-	tinput_position_caret(ti);
-}
-
-static void tinput_seek_max(tinput_t *ti, seek_dir_t dir)
-{
-	if (dir == seek_backward)
-		ti->pos = 0;
-	else
-		ti->pos = ti->nc;
-
-	tinput_position_caret(ti);
-}
-
-static void tinput_history_insert(tinput_t *ti, char *str)
-{
-	int i;
-
-	if (ti->hnum < HISTORY_LEN) {
-		ti->hnum += 1;
-	} else {
-		if (ti->history[HISTORY_LEN] != NULL)
-			free(ti->history[HISTORY_LEN]);
-	}
-
-	for (i = ti->hnum; i > 1; --i)
-		ti->history[i] = ti->history[i - 1];
-
-	ti->history[1] = str_dup(str);
-
-	if (ti->history[0] != NULL) {
-		free(ti->history[0]);
-		ti->history[0] = NULL;
-	}
-}
-
-static void tinput_set_str(tinput_t *ti, char *str)
-{
-	str_to_wstr(ti->buffer, INPUT_MAX, str);
-	ti->nc = wstr_length(ti->buffer);
-	ti->pos = ti->nc;
-}
-
-static void tinput_history_seek(tinput_t *ti, int offs)
-{
-	int pad;
-
-	if (ti->hpos + offs < 0 || ti->hpos + offs > ti->hnum)
-		return;
-
-	if (ti->history[ti->hpos] != NULL) {
-		free(ti->history[ti->hpos]);
-		ti->history[ti->hpos] = NULL;
-	}
-
-	ti->history[ti->hpos] = tinput_get_str(ti);
-	ti->hpos += offs;
-
-	pad = ti->nc - str_length(ti->history[ti->hpos]);
-	if (pad < 0) pad = 0;
-
-	tinput_set_str(ti, ti->history[ti->hpos]);
-	tinput_display_tail(ti, 0, pad);
-	tinput_update_origin(ti);
-	tinput_position_caret(ti);
-}
-
-static void tinput_init(tinput_t *ti)
-{
-	ti->hnum = 0;
-	ti->hpos = 0;
-	ti->history[0] = NULL;
-}
-
-static char *tinput_read(tinput_t *ti)
+static void read_line(char *buffer, int n)
 {
 	console_event_t ev;
-	char *str;
+	size_t offs, otmp;
+	wchar_t dec;
 
-	fflush(stdout);
-
-	if (console_get_size(fphone(stdin), &ti->con_cols, &ti->con_rows) != EOK)
-		return NULL;
-	if (console_get_pos(fphone(stdin), &ti->col0, &ti->row0) != EOK)
-		return NULL;
-
-	ti->pos = 0;
-	ti->nc = 0;
-	ti->buffer[0] = '\0';
-
+	offs = 0;
 	while (true) {
 		fflush(stdout);
 		if (!console_get_event(fphone(stdin), &ev))
-			return NULL;
+			return;
 		
 		if (ev.type != KEY_PRESS)
 			continue;
-
-		if ((ev.mods & KM_CTRL) != 0 &&
-		    (ev.mods & (KM_ALT | KM_SHIFT)) == 0) {
-			switch (ev.key) {
-			case KC_LEFT:
-				tinput_seek_word(ti, seek_backward);
-				break;
-			case KC_RIGHT:
-				tinput_seek_word(ti, seek_forward);
-				break;
-			case KC_UP:
-				tinput_seek_vertical(ti, seek_backward);
-				break;
-			case KC_DOWN:
-				tinput_seek_vertical(ti, seek_forward);
-				break;
+		
+		if (ev.key == KC_ENTER || ev.key == KC_NENTER)
+			break;
+		if (ev.key == KC_BACKSPACE) {
+			if (offs > 0) {
+				/*
+				 * Back up until we reach valid start of
+				 * character.
+				 */
+				while (offs > 0) {
+					--offs; otmp = offs;
+					dec = str_decode(buffer, &otmp, n);
+					if (dec != U_SPECIAL)
+						break;
+				}
+				putchar('\b');
 			}
+			continue;
 		}
-
-		if ((ev.mods & (KM_CTRL | KM_ALT | KM_SHIFT)) == 0) {
-			switch (ev.key) {
-			case KC_ENTER:
-			case KC_NENTER:
-				goto done;
-			case KC_BACKSPACE:
-				tinput_backspace(ti);
-				break;
-			case KC_DELETE:
-				tinput_delete(ti);
-				break;
-			case KC_LEFT:
-				tinput_seek_cell(ti, seek_backward);
-				break;
-			case KC_RIGHT:
-				tinput_seek_cell(ti, seek_forward);
-				break;
-			case KC_HOME:
-				tinput_seek_max(ti, seek_backward);
-				break;
-			case KC_END:
-				tinput_seek_max(ti, seek_forward);
-				break;
-			case KC_UP:
-				tinput_history_seek(ti, +1);
-				break;
-			case KC_DOWN:
-				tinput_history_seek(ti, -1);
-				break;
-			}
-		}
-
 		if (ev.c >= ' ') {
-			tinput_insert_char(ti, ev.c);
+			if (chr_encode(ev.c, buffer, &offs, n - 1) == EOK)
+				putchar(ev.c);
 		}
 	}
-
-done:
-	ti->pos = ti->nc;
-	tinput_position_caret(ti);
 	putchar('\n');
-
-	str = tinput_get_str(ti);
-	if (str_cmp(str, "") != 0)
-		tinput_history_insert(ti, str);
-
-	ti->hpos = 0;
-
-	return str;
+	buffer[offs] = '\0';
 }
 
+/* TODO:
+ * Implement something like editline() / readline(), if even
+ * just for command history and making arrows work. */
 void get_input(cliuser_t *usr)
 {
-	char *str;
+	char line[INPUT_MAX];
 
 	fflush(stdout);
@@ -447,18 +154,11 @@
 	console_set_style(fphone(stdout), STYLE_NORMAL);
 
-	str = tinput_read(&tinput);
+	read_line(line, INPUT_MAX);
+	/* Make sure we don't have rubbish or a C/R happy user */
+	if (str_cmp(line, "") == 0 || str_cmp(line, "\n") == 0)
+		return;
+	usr->line = str_dup(line);
 
-	/* Check for empty input. */
-	if (str_cmp(str, "") == 0) {
-		free(str);
-		return;
-	}
-
-	usr->line = str;
 	return;
 }
 
-void input_init(void)
-{
-	tinput_init(&tinput);
-}
Index: uspace/app/bdsh/input.h
===================================================================
--- uspace/app/bdsh/input.h	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ uspace/app/bdsh/input.h	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -8,5 +8,4 @@
 extern void get_input(cliuser_t *);
 extern int tok_input(cliuser_t *);
-extern void input_init(void);
 
 #endif
Index: uspace/app/bdsh/scli.c
===================================================================
--- uspace/app/bdsh/scli.c	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ uspace/app/bdsh/scli.c	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -64,7 +64,4 @@
 	usr->prompt = (char *) NULL;
 	usr->lasterr = 0;
-
-	input_init();
-
 	return (int) cli_set_prompt(usr);
 }
Index: uspace/app/edit/edit.c
===================================================================
--- uspace/app/edit/edit.c	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ uspace/app/edit/edit.c	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -36,5 +36,4 @@
 
 #include <stdio.h>
-#include <stdlib.h>
 #include <sys/types.h>
 #include <vfs/vfs.h>
@@ -102,15 +101,10 @@
 #define ED_INFTY 65536
 
-/** Maximum filename length that can be entered. */
-#define INFNAME_MAX_LEN 128
-
 static void key_handle_unmod(console_event_t const *ev);
 static void key_handle_ctrl(console_event_t const *ev);
 static int file_save(char const *fname);
-static void file_save_as(void);
 static int file_insert(char *fname);
 static int file_save_range(char const *fname, spt_t const *spos,
     spt_t const *epos);
-static char *filename_prompt(char const *prompt, char const *init_value);
 static void pane_text_display(void);
 static void pane_row_display(void);
@@ -156,15 +150,15 @@
 
 	if (argc == 2) {
-		doc.file_name = str_dup(argv[1]);
+		doc.file_name = argv[1];
 	} else if (argc > 1) {
 		printf("Invalid arguments.\n");
 		return -2;
 	} else {
-		doc.file_name = NULL;
+		doc.file_name = "/edit.txt";
 	}
 
 	new_file = false;
 
-	if (doc.file_name == NULL || file_insert(doc.file_name) != EOK)
+	if (file_insert(doc.file_name) != EOK)
 		new_file = true;
 
@@ -176,6 +170,6 @@
 	pane_text_display();
 	pane_status_display();
-	if (new_file && doc.file_name != NULL)
-		status_display("File not found. Starting empty file.");
+	if (new_file)
+		status_display("File not found. Created empty file.");
 	pane_caret_display();
 
@@ -272,11 +266,5 @@
 		break;
 	case KC_S:
-		if (doc.file_name != NULL)
-			file_save(doc.file_name);
-		else
-			file_save_as();
-		break;
-	case KC_E:
-		file_save_as();
+		(void) file_save(doc.file_name);
 		break;
 	default:
@@ -284,4 +272,5 @@
 	}
 }
+
 
 /** Save the document. */
@@ -296,104 +285,7 @@
 
 	rc = file_save_range(fname, &sp, &ep);
-
-	switch (rc) {
-	case EINVAL:
-		status_display("Error opening file!");
-		break;
-	case EIO:
-		status_display("Error writing data!");
-		break;
-	default:
-		status_display("File saved.");
-		break;
-	}
+	status_display("File saved.");
 
 	return rc;
-}
-
-/** Change document name and save. */
-static void file_save_as(void)
-{
-	char *old_fname, *fname;
-	int rc;
-
-	old_fname = (doc.file_name != NULL) ? doc.file_name : "";
-	fname = filename_prompt("Save As", old_fname);
-	if (fname == NULL) {
-		status_display("Save cancelled.");
-		return;
-	}
-
-	rc = file_save(fname);
-	if (rc != EOK)
-		return;
-
-	if (doc.file_name != NULL)
-		free(doc.file_name);
-	doc.file_name = fname;
-}
-
-/** Ask for a file name. */
-static char *filename_prompt(char const *prompt, char const *init_value)
-{
-	console_event_t ev;
-	char *str;
-	wchar_t buffer[INFNAME_MAX_LEN + 1];
-	int max_len;
-	int nc;
-	bool done;
-
-	asprintf(&str, "%s: %s", prompt, init_value);
-	status_display(str);
-	console_goto(con, 1 + str_length(str), scr_rows - 1);
-	free(str);
-
-	console_set_color(con, COLOR_WHITE, COLOR_BLACK, 0);
-
-	max_len = min(INFNAME_MAX_LEN, scr_columns - 4 - str_length(prompt));
-	str_to_wstr(buffer, max_len + 1, init_value);
-	nc = wstr_length(buffer);
-	done = false;
-
-	while (!done) {
-		console_get_event(con, &ev);
-
-		if (ev.type == KEY_PRESS) {
-			/* Handle key press. */
-			if (((ev.mods & KM_ALT) == 0) &&
-			     (ev.mods & KM_CTRL) != 0) {
-				;
-			} else if ((ev.mods & (KM_CTRL | KM_ALT)) == 0) {
-				switch (ev.key) {
-				case KC_ESCAPE:
-					return NULL;
-				case KC_BACKSPACE:
-					if (nc > 0) {
-						putchar('\b');
-						fflush(stdout);
-						--nc;
-					}
-					break;
-				case KC_ENTER:
-					done = true;
-					break;
-				default:
-					if (ev.c >= 32 && nc < max_len) {
-						putchar(ev.c);
-						fflush(stdout);
-						buffer[nc++] = ev.c;
-					}
-					break;
-				}
-			}
-		}
-	}
-
-	buffer[nc] = '\0';
-	str = wstr_to_astr(buffer);
-
-	console_set_color(con, COLOR_BLACK, COLOR_WHITE, 0);
-
-	return str;
 }
 
@@ -467,6 +359,5 @@
 	} while (!spt_equal(&bep, epos));
 
-	if (fclose(f) != EOK)
-		return EIO;
+	fclose(f);
 
 	return EOK;
@@ -582,5 +473,4 @@
 	spt_t caret_pt;
 	coord_t coord;
-	char *fname;
 	int n;
 
@@ -588,10 +478,8 @@
 	spt_get_coord(&caret_pt, &coord);
 
-	fname = (doc.file_name != NULL) ? doc.file_name : "<unnamed>";
-
 	console_goto(con, 0, scr_rows - 1);
 	console_set_color(con, COLOR_WHITE, COLOR_BLACK, 0);
-	n = printf(" %d, %d: File '%s'. Ctrl-Q Quit  Ctrl-S Save  "
-	    "Ctrl-E Save As", coord.row, coord.column, fname);
+	n = printf(" %d, %d: File '%s'. Ctrl-S Save  Ctrl-Q Quit",
+	    coord.row, coord.column, doc.file_name);
 	printf("%*s", scr_columns - 1 - n, "");
 	fflush(stdout);
Index: uspace/lib/libc/arch/amd64/include/atomic.h
===================================================================
--- uspace/lib/libc/arch/amd64/include/atomic.h	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ uspace/lib/libc/arch/amd64/include/atomic.h	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -37,8 +37,4 @@
 #ifndef LIBC_amd64_ATOMIC_H_
 #define LIBC_amd64_ATOMIC_H_
-
-#define LIBC_ARCH_ATOMIC_H_
-
-#include <atomicdflt.h>
 
 static inline void atomic_inc(atomic_t *val) {
Index: uspace/lib/libc/arch/arm32/include/atomic.h
===================================================================
--- uspace/lib/libc/arch/arm32/include/atomic.h	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ uspace/lib/libc/arch/arm32/include/atomic.h	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -37,30 +37,4 @@
 #define LIBC_arm32_ATOMIC_H_
 
-#include <bool.h>
-
-typedef struct atomic {
-	volatile long count;
-} atomic_t;
-
-static inline void atomic_set(atomic_t *val, long i)
-{
-        val->count = i;
-}
-
-static inline long atomic_get(atomic_t *val)
-{
-        return val->count;
-}
-
-static inline bool cas(atomic_t *val, long ov, long nv)
-{
-	/* FIXME: is not atomic */
-	if (val->count == ov) {
-		val->count = nv;
-		return true;
-	}
-	return false;
-}
-
 /** Atomic addition.
  *
@@ -75,5 +49,4 @@
 	volatile long * mem = &(val->count);
 
-	/* FIXME: is not atomic, is broken */
 	asm volatile (
 	"1:\n"
Index: uspace/lib/libc/arch/ia32/Makefile.inc
===================================================================
--- uspace/lib/libc/arch/ia32/Makefile.inc	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ uspace/lib/libc/arch/ia32/Makefile.inc	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -39,5 +39,4 @@
 	arch/$(UARCH)/src/setjmp.S
 
-GCC_CFLAGS += -march=pentium
 LFLAGS += -N
 
Index: uspace/lib/libc/arch/ia32/include/atomic.h
===================================================================
--- uspace/lib/libc/arch/ia32/include/atomic.h	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ uspace/lib/libc/arch/ia32/include/atomic.h	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -35,8 +35,4 @@
 #ifndef LIBC_ia32_ATOMIC_H_
 #define LIBC_ia32_ATOMIC_H_
-
-#define LIBC_ARCH_ATOMIC_H_
-
-#include <atomicdflt.h>
 
 static inline void atomic_inc(atomic_t *val) {
Index: uspace/lib/libc/arch/ia64/include/atomic.h
===================================================================
--- uspace/lib/libc/arch/ia64/include/atomic.h	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ uspace/lib/libc/arch/ia64/include/atomic.h	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -35,8 +35,4 @@
 #ifndef LIBC_ia64_ATOMIC_H_
 #define LIBC_ia64_ATOMIC_H_
-
-#define LIBC_ARCH_ATOMIC_H_
-
-#include <atomicdflt.h>
 
 static inline void atomic_inc(atomic_t *val)
Index: uspace/lib/libc/arch/mips32/include/atomic.h
===================================================================
--- uspace/lib/libc/arch/mips32/include/atomic.h	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ uspace/lib/libc/arch/mips32/include/atomic.h	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -36,8 +36,4 @@
 #ifndef LIBC_mips32_ATOMIC_H_
 #define LIBC_mips32_ATOMIC_H_
-
-#define LIBC_ARCH_ATOMIC_H_
-
-#include <atomicdflt.h>
 
 #define atomic_inc(x)	((void) atomic_add(x, 1))
Index: uspace/lib/libc/arch/ppc32/include/atomic.h
===================================================================
--- uspace/lib/libc/arch/ppc32/include/atomic.h	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ uspace/lib/libc/arch/ppc32/include/atomic.h	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -35,8 +35,4 @@
 #ifndef LIBC_ppc32_ATOMIC_H_
 #define LIBC_ppc32_ATOMIC_H_
-
-#define LIBC_ARCH_ATOMIC_H_
-
-#include <atomicdflt.h>
 
 static inline void atomic_inc(atomic_t *val)
Index: uspace/lib/libc/arch/sparc64/include/atomic.h
===================================================================
--- uspace/lib/libc/arch/sparc64/include/atomic.h	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ uspace/lib/libc/arch/sparc64/include/atomic.h	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -36,7 +36,4 @@
 #define LIBC_sparc64_ATOMIC_H_
 
-#define LIBC_ARCH_ATOMIC_H_
-
-#include <atomicdflt.h>
 #include <sys/types.h>
 
Index: uspace/lib/libc/generic/async.c
===================================================================
--- uspace/lib/libc/generic/async.c	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ uspace/lib/libc/generic/async.c	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -392,18 +392,4 @@
 	/* If nothing in queue, wait until something arrives */
 	while (list_empty(&conn->msg_queue)) {
-		if (conn->close_callid) {
-			/*
-			 * Handle the case when the connection was already
-			 * closed by the client but the server did not notice
-			 * the first IPC_M_PHONE_HUNGUP call and continues to
-			 * call async_get_call_timeout(). Repeat
-			 * IPC_M_PHONE_HUNGUP until the caller notices. 
-			 */
-			memset(call, 0, sizeof(ipc_call_t));
-			IPC_SET_METHOD(*call, IPC_M_PHONE_HUNGUP);
-			futex_up(&async_futex);
-			return conn->close_callid;
-		}
-
 		if (usecs)
 			async_insert_timeout(&conn->wdata);
@@ -542,5 +528,5 @@
 	list_initialize(&conn->msg_queue);
 	conn->callid = callid;
-	conn->close_callid = 0;
+	conn->close_callid = false;
 	
 	if (call)
Index: uspace/lib/libc/generic/futex.c
===================================================================
--- uspace/lib/libc/generic/futex.c	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ uspace/lib/libc/generic/futex.c	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -36,5 +36,49 @@
 #include <atomic.h>
 #include <libc.h>
+#include <stdio.h>
 #include <sys/types.h>
+#include <kernel/synch/synch.h>
+
+/*
+ * Note about race conditions.
+ * Because of non-atomic nature of operations performed sequentially on the
+ * futex counter and the futex wait queue, there is a race condition:
+ *
+ * (wq->missed_wakeups == 1) && (futex->count = 1)
+ *
+ * Scenario 1 (wait queue timeout vs. futex_up()):
+ * 1. assume wq->missed_wakeups == 0 && futex->count == -1
+ *    (ie. thread A sleeping, thread B in the critical section)
+ * 2. A receives timeout and gets removed from the wait queue
+ * 3. B wants to leave the critical section and calls futex_up()
+ * 4. B thus changes futex->count from -1 to 0
+ * 5. B has to call SYS_FUTEX_WAKEUP syscall to wake up the sleeping thread
+ * 6. B finds the wait queue empty and changes wq->missed_wakeups from 0 to 1
+ * 7. A fixes futex->count (i.e. the number of waiting threads) by changing it
+ *    from 0 to 1
+ *
+ * Scenario 2 (conditional down operation vs. futex_up)
+ * 1. assume wq->missed_wakeups == 0 && futex->count == 0
+ *    (i.e. thread A is in the critical section)
+ * 2. thread B performs futex_trydown() operation and changes futex->count from
+ *    0 to -1
+ *    B is now obliged to call SYS_FUTEX_SLEEP syscall
+ * 3. A wants to leave the critical section and does futex_up()
+ * 4. A thus changes futex->count from -1 to 0 and must call SYS_FUTEX_WAKEUP
+ *    syscall
+ * 5. B finds the wait queue empty and immediatelly aborts the conditional sleep
+ * 6. No thread is queueing in the wait queue so wq->missed_wakeups changes from
+ *    0 to 1
+ * 6. B fixes futex->count (i.e. the number of waiting threads) by changing it
+ *    from 0 to 1
+ *
+ * Both scenarios allow two threads to be in the critical section
+ * simultaneously. One without kernel intervention and the other through
+ * wq->missed_wakeups being 1.
+ *
+ * To mitigate this problem, futex_down_timeout() detects that the syscall
+ * didn't sleep in the wait queue, fixes the futex counter and RETRIES the
+ * whole operation again.
+ */
 
 /** Initialize futex counter.
@@ -48,28 +92,81 @@
 }
 
+int futex_down(futex_t *futex)
+{
+	return futex_down_timeout(futex, SYNCH_NO_TIMEOUT, SYNCH_FLAGS_NONE);
+}
+
+int futex_trydown(futex_t *futex)
+{
+	return futex_down_timeout(futex, SYNCH_NO_TIMEOUT,
+	    SYNCH_FLAGS_NON_BLOCKING);
+}
+
 /** Try to down the futex.
  *
  * @param futex		Futex.
- * @return		Non-zero if the futex was acquired.
- * @return		Zero if the futex was not acquired.
+ * @param usec		Microseconds to wait. Zero value means sleep without
+ * 			timeout.
+ * @param flags		Select mode of operation. See comment for
+ * 			waitq_sleep_timeout(). 
+ *
+ * @return		ENOENT if there is no such virtual address. One of
+ * 			ESYNCH_OK_ATOMIC and ESYNCH_OK_BLOCKED on success or
+ * 			ESYNCH_TIMEOUT if the lock was not acquired because of
+ * 			a timeout or ESYNCH_WOULD_BLOCK if the operation could
+ * 			not be carried out atomically (if requested so).
  */
-int futex_trydown(futex_t *futex)
+int futex_down_timeout(futex_t *futex, uint32_t usec, int flags)
 {
-	return cas(futex, 1, 0);
-}
+	int rc;
+	
+	while (atomic_predec(futex) < 0) {
+		rc = __SYSCALL3(SYS_FUTEX_SLEEP, (sysarg_t) &futex->count,
+		    (sysarg_t) usec, (sysarg_t) flags);
+		
+		switch (rc) {
+		case ESYNCH_OK_ATOMIC:
+			/*
+			 * Because of a race condition between timeout and
+			 * futex_up() and between conditional
+			 * futex_down_timeout() and futex_up(), we have to give
+			 * up and try again in this special case.
+			 */
+			atomic_inc(futex);
+			break;
 
-/** Down the futex.
- *
- * @param futex		Futex.
- * @return		ENOENT if there is no such virtual address.
- * @return		Zero in the uncontended case. 
- * @return		Otherwise one of ESYNCH_OK_ATOMIC or ESYNCH_OK_BLOCKED.
- */
-int futex_down(futex_t *futex)
-{
-	if (atomic_predec(futex) < 0)
-		return __SYSCALL1(SYS_FUTEX_SLEEP, (sysarg_t) &futex->count);
+		case ESYNCH_TIMEOUT:
+			atomic_inc(futex);
+			return ESYNCH_TIMEOUT;
+			break;
 
-	return 0;
+		case ESYNCH_WOULD_BLOCK:
+			/*
+			 * The conditional down operation should be implemented
+			 * this way. The userspace-only variant tends to
+			 * accumulate missed wakeups in the kernel futex wait
+			 * queue.
+			 */
+			atomic_inc(futex);
+			return ESYNCH_WOULD_BLOCK;
+			break;
+
+		case ESYNCH_OK_BLOCKED:
+			/*
+			 * Enter the critical section.
+			 * The futex counter has already been incremented for
+			 * us.
+			 */
+			return ESYNCH_OK_BLOCKED;
+			break;
+		default:
+			return rc;
+		}
+	}
+
+	/*
+	 * Enter the critical section.
+	 */
+	return ESYNCH_OK_ATOMIC;
 }
 
@@ -77,10 +174,14 @@
  *
  * @param futex		Futex.
- * @return		ENOENT if there is no such virtual address.
- * @return		Zero in the uncontended case.
+ *
+ * @return		ENOENT if there is no such virtual address. Otherwise
+ * 			zero.
  */
 int futex_up(futex_t *futex)
 {
-	if (atomic_postinc(futex) < 0)
+	long val;
+	
+	val = atomic_postinc(futex);
+	if (val < 0)
 		return __SYSCALL1(SYS_FUTEX_WAKEUP, (sysarg_t) &futex->count);
 		
Index: uspace/lib/libc/generic/io/console.c
===================================================================
--- uspace/lib/libc/generic/io/console.c	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ uspace/lib/libc/generic/io/console.c	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -94,17 +94,4 @@
 }
 
-int console_get_pos(int phone, int *col, int *row)
-{
-	ipcarg_t col_v;
-	ipcarg_t row_v;
-	int rc;
-
-	rc = async_req_0_2(phone, CONSOLE_GET_POS, &col_v, &row_v);
-
-	*col = (int) col_v;
-	*row = (int) row_v;
-	return rc;
-}
-
 void console_goto(int phone, int col, int row)
 {
Index: uspace/lib/libc/generic/io/klog.c
===================================================================
--- uspace/lib/libc/generic/io/klog.c	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ uspace/lib/libc/generic/io/klog.c	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -42,10 +42,5 @@
 size_t klog_write(const void *buf, size_t size)
 {
-	ssize_t ret = (ssize_t) __SYSCALL3(SYS_KLOG, 1, (sysarg_t) buf, size);
-	
-	if (ret >= 0)
-		return (size_t) ret;
-	
-	return 0;
+	return (size_t) __SYSCALL3(SYS_KLOG, 1, (sysarg_t) buf, size);
 }
 
Index: uspace/lib/libc/generic/string.c
===================================================================
--- uspace/lib/libc/generic/string.c	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ uspace/lib/libc/generic/string.c	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -471,5 +471,5 @@
  * null-terminated and containing only complete characters.
  *
- * @param dest   Destination buffer.
+ * @param dst   Destination buffer.
  * @param count Size of the destination buffer (must be > 0).
  * @param src   Source string.
@@ -505,5 +505,5 @@
  * have to be null-terminated.
  *
- * @param dest   Destination buffer.
+ * @param dst   Destination buffer.
  * @param count Size of the destination buffer (must be > 0).
  * @param src   Source string.
@@ -537,5 +537,5 @@
  * null-terminated and containing only complete characters.
  *
- * @param dest   Destination buffer.
+ * @param dst   Destination buffer.
  * @param count Size of the destination buffer.
  * @param src   Source string.
@@ -549,113 +549,36 @@
 }
 
-/** Convert wide string to string.
- *
- * Convert wide string @a src to string. The output is written to the buffer
- * specified by @a dest and @a size. @a size must be non-zero and the string
- * written will always be well-formed.
- *
- * @param dest	Destination buffer.
- * @param size	Size of the destination buffer.
- * @param src	Source wide string.
- */
-void wstr_to_str(char *dest, size_t size, const wchar_t *src)
-{
+/** Copy NULL-terminated wide string to string
+ *
+ * Copy source wide string @a src to destination buffer @a dst.
+ * No more than @a size bytes are written. NULL-terminator is always
+ * written after the last succesfully copied character (i.e. if the
+ * destination buffer is has at least 1 byte, it will be always
+ * NULL-terminated).
+ *
+ * @param src   Source wide string.
+ * @param dst   Destination buffer.
+ * @param count Size of the destination buffer.
+ *
+ */
+void wstr_nstr(char *dst, const wchar_t *src, size_t size)
+{
+	/* No space for the NULL-terminator in the buffer */
+	if (size == 0)
+		return;
+	
 	wchar_t ch;
-	size_t src_idx;
-	size_t dest_off;
-
-	/* There must be space for a null terminator in the buffer. */
-	assert(size > 0);
-	
-	src_idx = 0;
-	dest_off = 0;
-
+	size_t src_idx = 0;
+	size_t dst_off = 0;
+	
 	while ((ch = src[src_idx++]) != 0) {
-		if (chr_encode(ch, dest, &dest_off, size - 1) != EOK)
+		if (chr_encode(ch, dst, &dst_off, size) != EOK)
 			break;
 	}
-
-	dest[dest_off] = '\0';
-}
-
-/** Convert wide string to new string.
- *
- * Convert wide string @a src to string. Space for the new string is allocated
- * on the heap.
- *
- * @param src	Source wide string.
- * @return	New string.
- */
-char *wstr_to_astr(const wchar_t *src)
-{
-	char dbuf[STR_BOUNDS(1)];
-	char *str;
-	wchar_t ch;
-
-	size_t src_idx;
-	size_t dest_off;
-	size_t dest_size;
-
-	/* Compute size of encoded string. */
-
-	src_idx = 0;
-	dest_size = 0;
-
-	while ((ch = src[src_idx++]) != 0) {
-		dest_off = 0;
-		if (chr_encode(ch, dbuf, &dest_off, STR_BOUNDS(1)) != EOK)
-			break;
-		dest_size += dest_off;
-	}
-
-	str = malloc(dest_size + 1);
-	if (str == NULL)
-		return NULL;
-
-	/* Encode string. */
-
-	src_idx = 0;
-	dest_off = 0;
-
-	while ((ch = src[src_idx++]) != 0) {
-		if (chr_encode(ch, str, &dest_off, dest_size) != EOK)
-			break;
-	}
-
-	str[dest_size] = '\0';
-	return str;
-}
-
-
-/** Convert string to wide string.
- *
- * Convert string @a src to wide string. The output is written to the
- * buffer specified by @a dest and @a dlen. @a dlen must be non-zero
- * and the wide string written will always be null-terminated.
- *
- * @param dest	Destination buffer.
- * @param dlen	Length of destination buffer (number of wchars).
- * @param src	Source string.
- */
-void str_to_wstr(wchar_t *dest, size_t dlen, const char *src)
-{
-	size_t offset;
-	size_t di;
-	wchar_t c;
-
-	assert(dlen > 0);
-
-	offset = 0;
-	di = 0;
-
-	do {
-		if (di >= dlen - 1)
-			break;
-
-		c = str_decode(src, &offset, STR_NO_LIMIT);
-		dest[di++] = c;
-	} while (c != '\0');
-
-	dest[dlen - 1] = '\0';
+	
+	if (dst_off >= size)
+		dst[size - 1] = 0;
+	else
+		dst[dst_off] = 0;
 }
 
Index: uspace/lib/libc/generic/time.c
===================================================================
--- uspace/lib/libc/generic/time.c	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ uspace/lib/libc/generic/time.c	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -31,5 +31,5 @@
  */
 /** @file
- */
+ */ 
 
 #include <sys/time.h>
@@ -40,7 +40,7 @@
 #include <unistd.h>
 #include <atomic.h>
+#include <futex.h>
 #include <sysinfo.h>
 #include <ipc/services.h>
-#include <libc.h>
 
 #include <sysinfo.h>
@@ -189,20 +189,27 @@
 
 /** Wait unconditionally for specified number of microseconds */
-int usleep(useconds_t usec)
-{
-	(void) __SYSCALL1(SYS_THREAD_USLEEP, usec);
+int usleep(unsigned long usec)
+{
+	atomic_t futex = FUTEX_INITIALIZER;
+
+	futex_initialize(&futex, 0);
+	futex_down_timeout(&futex, usec, 0);
 	return 0;
 }
 
 /** Wait unconditionally for specified number of seconds */
-unsigned int sleep(unsigned int sec)
-{
+unsigned int sleep(unsigned int seconds)
+{
+	atomic_t futex = FUTEX_INITIALIZER;
+
+	futex_initialize(&futex, 0);
+	
 	/* Sleep in 1000 second steps to support
 	   full argument range */
-	while (sec > 0) {
-		unsigned int period = (sec > 1000) ? 1000 : sec;
+	while (seconds > 0) {
+		unsigned int period = (seconds > 1000) ? 1000 : seconds;
 	
-		usleep(period * 1000000);
-		sec -= period;
+		futex_down_timeout(&futex, period * 1000000, 0);
+		seconds -= period;
 	}
 	return 0;
